Immich
===

Immich is a self-hosted backup solution for photos and videos on mobile device.

This kustomization provide a basic setup for an immich instance on Kubernetes. For a functional setup, there are some components you have to implement yourself:

- [postgresql](./postgres-zalando/)
- [redis-spotahome](./redis-spotahome/) or [redis-keydb](./redis-keydb/)
- [prometheus-monitoring](./prometheus-monitoring/)
- [ingress](../../k8s01/immich/ingress.yaml)

There are components used in the SI-Infrastructure, but they rely on operators that might not fix your setup.

You can also overwrite configs globally using a optional secret called `immich-env-override`.

Be aware that you might need to adjust some configs, like the `IMMICH_MACHINE_LEARNING_URL` if you use the kustomize prefix or suffix features.

Usage
---

Create a `kustomization.yaml` in your gitops setup:

```yaml
# kustomization.yaml
apiVersion: kustomize.config.k8s.io/v1beta1
kind: Kustomization
namespace: immich
resources:
  - https://git.shivering-isles.com/shivering-isles/infrastructure-gitops//apps/base/immich?ref=main
  - ingress.yaml
components:
  - https://git.shivering-isles.com/shivering-isles/infrastructure-gitops//apps/base/immich/postgres-zalando?ref=main
  - https://git.shivering-isles.com/shivering-isles/infrastructure-gitops//apps/base/immich/redis-spotahome?ref=main
```

Add an `ingress.yaml` and add the components for postgres and redis.

Deploy it all using your GitOps toolchain.

Origin
---

This kustomization has drawn quite some inspiration from the upstream helm chart, but allows easier overwrites and replacements and doesn't rely on a abstracted helm chart.

This switch makes it easier to integrate Operator-based components and adjustments.

Links
---

- [Source Code](https://github.com/immich-app/immich)
- [Documentation](https://immich.app/docs/overview/introduction)
- [Forum](https://github.com/immich-app/immich/discussions)
- [Kustomization](https://git.shivering-isles.com/shivering-isles/infrastructure-gitops/-/tree/main/apps/base/immich?ref_type=heads)
