#!/bin/bash

set -e
set -o pipefail

echo "Current Integrity file: ${INTEGRITY_FILE_REPOSITORY?}"

INTEGRITY_FILE="${INTEGRITY_FILE_REPOSITORY?}/current.txt"
INTEGRITY_FILE_NEW="${INTEGRITY_FILE_REPOSITORY?}/new.txt"
INTEGRITY_FILE_ARCHIVE_DIR="${INTEGRITY_FILE_REPOSITORY?}/archive/$(date +%Y/%m/%d)"

if [ "$INTEGRITY_FILE_INIT" = "true" ]; then
    mkdir -p ${INTEGRITY_FILE_REPOSITORY?}
    touch "${INTEGRITY_FILE?}"
else
    # Check current file integrity
    sha256sum --strict -c "${INTEGRITY_FILE?}"
fi

# Generate new file integrity table
find upload/library/ -type f -a -ctime +15 -a \( -iname '*.png' -o -iname "*.jpg"  -o -iname "*.jpeg" \) -exec sha256sum {} \; > "${INTEGRITY_FILE_NEW?}"

# Archiving new file integrity tables
mkdir -p "${INTEGRITY_FILE_ARCHIVE_DIR?}"
cp "${INTEGRITY_FILE_NEW}" "${INTEGRITY_FILE_ARCHIVE_DIR?}/$(date +%s).txt"
cp "${INTEGRITY_FILE?}" "${INTEGRITY_FILE?}.prev"
mv "${INTEGRITY_FILE_NEW?}" "${INTEGRITY_FILE?}"

# TODO: Cleanup archive over time