s3dav-proxy
===

s3dav-proxy is a simple proxy service that translates webdav calls to minio S3 calls, providing an easy way to integrate webdav-based applications, like GrapheneOS' Seedvault implementations with Minio.

In order to use it, one needs to specify a minio backend:

```yaml
patches:
  - patch: |
      - op: add
        path: /spec/template/spec/containers/0/args/-
        value: --secure
      - op: add
        path: /spec/template/spec/containers/0/args/-
        value: --endpoint
      - op: add
        path: /spec/template/spec/containers/0/args/-
        value: minio.example.com:9000
    target:
      group: apps
      version: v1
      kind: 'Deployment'
      name: s3dav-proxy
```

This can be done as part of your customization.

Links
---

- [Source Code](https://git.shivering-isles.com/shivering-isles/s3dav-proxy)
- [Kustomization](https://git.shivering-isles.com/shivering-isles/infrastructure-gitops/-/tree/main/apps/base/s3dav-proxy?ref_type=heads)
- [Upstream Source Code](https://github.com/hrntknr/s3dav-proxy/)